import 'dart:async';

import 'package:modular_interfaces/modular_interfaces.dart';

import '../../modular_core.dart' show ModularTracker;

abstract class AsyncBindContract<T extends Object> extends BindContract<Future<T>> {
  final Future<T> Function(Injector i) asyncInject;

  AsyncBindContract(this.asyncInject, {bool export = false}) : super(asyncInject, export: export);

  Future<T> resolveAsyncBind() async {
    final bind = await asyncInject(ModularTracker.injector);
    return bind;
  }

  Future<BindContract<T>> convertToAsyncBind();
}
